;; benchmarks speed of array and sequence operations
;;
;; Author: Eric Marsden <emarsden@laas.fr>
;; Time-stamp: <2003-12-29 emarsden>
;;
;;
;; Timing tests for creation, initialization, access and garbage
;; collection for arrays, vectors, bitvectors and strings.
;;
;; NOTE: be careful running these in CMUCL on Linux with sizes larger
;; than your RAM; you will most likely crash your machine.


;;(in-package :cl-bench.arrays)

(deftype index ()
  `(INTEGER 0 (#.array-dimension-limit)))


;;(declaim (optimize (speed 3) (space 1) (safety 0) (debug 0) (compilation-speed 0)))
(declaim (optimize (speed 3) (space 1) (debug 0)))

(defun bench-1d-t-arrays (&optional (size 100000) (runs 100))
  (declare (fixnum size runs))
  (let ((ones (make-array size :element-type '(integer 0 1000) :initial-element 1))
        (twos (make-array size :element-type '(integer 0 1000) :initial-element 2))
        (threes (make-array size :element-type '(integer 0 2000)))
	(baz 0) (foo 0) (bar 0))
    ;(declare (type (vector fixnum) ones twos threes))
    (declare (type (vector (integer 0 1000)) ones twos) (type (vector (integer 0 2000)) threes))
    ;(declare (type (vector si:integer8) ones twos) (type (vector si:byte8) threes))
    ;(declare (type (vector fixnum) ones twos) (type (vector fixnum) threes))
    (declare (type (integer 0 1000) foo bar) (type (integer 0 2000) baz))
    (dotimes (run runs)
      (declare (index run))
      (dotimes (pos size)
	(declare (index pos))
	#+(and)
	;(setf (aref threes pos) (the fixnum (+ (the fixnum (aref ones pos)) (the fixnum (aref twos pos)))))
	;(setq foo (the fixnum (setf (aref threes pos) (the fixnum (+ (aref ones pos) (aref twos pos))))))
	;(setq foo (the (integer 0 200) (+ (aref ones pos) (aref twos pos))))
	(setq bar (aref twos pos))
	(setq foo (the (integer 0 1000) (aref ones pos)))
	;(setf (aref threes pos) foo)
	(si:aset (aref ones pos) twos pos)
	(si:aset foo twos pos)
	;(si:aset foo threes pos)
	(setq bar (setf (aref threes pos) foo))
	;(setq baz (setf (aref threes pos) (the (integer 0 2000) (+ (aref ones pos) (aref twos pos)))))
	(let ((it (the (integer 0 2000) (+ (aref ones pos) (aref twos pos)))))
	  (declare (type (integer 0 2000) it))
	  (si:aset it threes pos))
	(setq baz (the (integer 0 2000) (+ (the (integer 0 1000) (aref ones pos)) (the (integer 0 1000) (aref twos pos)))))
	(si:aset baz threes pos)
	;(setf (aref threes pos) (the (integer 0 200) (+ (aref ones pos) (aref twos pos))))
	)
      ;;(assert (null (search (list 4 5 6) threes)))
      ))
  (values))

