
(deftype index ()
  `(INTEGER 0 (#.array-dimension-limit)))


;;(declaim (optimize (speed 3) (space 1) (safety 0) (debug 0) (compilation-speed 0)))
(declaim (optimize (speed 3) (space 1) (debug 0)))


(defun bench-2d-arrays (&optional (size 2000) (runs 10))
  (declare (fixnum size))
  (let ((ones (make-array (list size size) :element-type '(integer 0 1000) :initial-element 1))
        (twos (make-array (list size size) :element-type '(integer 0 1000) :initial-element 2))
        (threes (make-array (list size size) :element-type '(integer 0 2000))))
    (declare (type (array (integer 0 1000) (* *)) ones twos) (type (array (integer 0 2000) (* *)) threes))
    (dotimes (run runs)
      (declare (index run))
      (dotimes (i size)
	(declare (index i))
        (dotimes (j size)
	  (declare (index j))
	  #+(or)
	  (setf (row-major-aref threes (array-row-major-index threes i j))
		(the (integer 0 2000) (+ (row-major-aref ones (array-row-major-index ones i j))
					 (row-major-aref twos (array-row-major-index twos i j)))))
	  #+(and)
          (setf (aref threes i j)
                (the (integer 0 2000) (+ (aref ones i j) (aref twos i j))))
	  ))
      ;;(assert (eql 3 (aref threes 3 3)))
      ))
  (values))
