
(deftype index ()
  `(INTEGER 0 (#.array-dimension-limit)))


;;(declaim (optimize (speed 3) (space 1) (safety 0) (debug 0) (compilation-speed 0)))
(declaim (optimize (speed 3) (space 1) (debug 0)))


(defun bench-2d-arrays (&optional (size 2000) (runs 10))
  (declare (fixnum size runs))
  (let ((ones (make-array (list size size) :element-type 'fixnum :initial-element 1))
        (twos (make-array (list size size) :element-type 'fixnum :initial-element 2))
        (threes (make-array (list size size) :element-type 'fixnum)))
    (declare (type (array fixnum (* *)) ones twos) (type (array fixnum (* *)) threes))
    (dotimes (run runs)
      (declare (index run))
      (dotimes (i size)
	(declare (index i))
        (dotimes (j size)
	  (declare (index j))
	  #+(and)
	  (setf (row-major-aref threes (array-row-major-index threes i j))
		(the fixnum (+ (row-major-aref ones (array-row-major-index ones i j))
					 (row-major-aref twos (array-row-major-index twos i j)))))
	  #+(or)
          (setf (aref threes i j)
                (the fixnum (+ (aref ones i j) (aref twos i j))))
	  ))
      ;;(assert (eql 3 (aref threes 3 3)))
      ))
  (values))
