;;

(require :rt)
(require :cffi)


(cffi:define-foreign-library (libtest_cb :type :test)
  (:darwin "libtest_cb.dylib")
  (:unix "libtest_cb.so")
  (:windows "libtest_cb.dll")
  (t (:default "libtest_cb")))

(let ((cffi:*foreign-library-directories* '(".")))
  (cffi:load-foreign-library 'libtest_cb))

;;;;;;;;


(cffi:defcfun "call_just_say_hello" :void (cb :pointer))

(cffi:defcallback just-say-hello :void ()
  (format t "~&Hello from lisp callback function!~%") (finish-output))

(cffi:defcfun "call_sum_4_long" :long (cb :pointer))

(cffi:defcallback sum-4-long :long ((a0 :long) (a1 :long) (a2 :long) (a3 :long))
  (format t "~&In sum-4-long: a0 = ~S, a1 = ~S, a2 = ~S, a3 = ~S.~%" a0 a1 a2 a3)
  (finish-output)
  (+ a0 a1 a2 a3))

(cffi:defcfun "call_sum_8_long" :long (cb :pointer))

(cffi:defcallback sum-8-long :long ((a0 :long) (a1 :long) (a2 :long) (a3 :long) (a4 :long) (a5 :long) (a6 :long) (a7 :long))
  (format t "~&In sum-8-long: a0 = ~S, a1 = ~S, a2 = ~S, a3 = ~S, a4 = ~S, a5 = ~S, a6 = ~S, a7 = ~S.~%" a0 a1 a2 a3 a4 a5 a6 a7)
  (finish-output)
  (+ a0 a1 a2 a3 a4 a5 a6 a7))



;;;;;;;;

(cffi:defcfun "call_sum_127_no_ll" :long (cb :pointer))

(cffi:defcallback sum-127-no-ll :long
    ((a1 :unsigned-long) (a2 :pointer) (a3 :long) (a4 :double)
     (a5 :unsigned-long) (a6 :float) (a7 :float) (a8 :int) (a9 :unsigned-int)
     (a10 :double) (a11 :double) (a12 :double) (a13 :pointer)
     (a14 :unsigned-short) (a15 :unsigned-short) (a16 :pointer) (a17 :long)
     (a18 :long) (a19 :int) (a20 :short) (a21 :unsigned-short)
     (a22 :unsigned-short) (a23 :char) (a24 :long) (a25 :pointer) (a26 :pointer)
     (a27 :char) (a28 :unsigned-char) (a29 :unsigned-long) (a30 :short)
     (a31 :int) (a32 :int) (a33 :unsigned-char) (a34 :short) (a35 :long)
     (a36 :long) (a37 :pointer) (a38 :unsigned-short) (a39 :char) (a40 :double)
     (a41 :unsigned-short) (a42 :pointer) (a43 :short) (a44 :unsigned-long)
     (a45 :unsigned-short) (a46 :float) (a47 :unsigned-char) (a48 :short)
     (a49 :float) (a50 :short) (a51 :char) (a52 :unsigned-long)
     (a53 :unsigned-long) (a54 :char) (a55 :float) (a56 :long) (a57 :pointer)
     (a58 :short) (a59 :float) (a60 :unsigned-int) (a61 :float)
     (a62 :unsigned-int) (a63 :double) (a64 :unsigned-int) (a65 :unsigned-char)
     (a66 :int) (a67 :long) (a68 :char) (a69 :short) (a70 :double) (a71 :int)
     (a72 :pointer) (a73 :char) (a74 :unsigned-short) (a75 :pointer)
     (a76 :unsigned-short) (a77 :pointer) (a78 :unsigned-long) (a79 :double)
     (a80 :pointer) (a81 :long) (a82 :float) (a83 :unsigned-short)
     (a84 :unsigned-short) (a85 :pointer) (a86 :float) (a87 :int)
     (a88 :unsigned-int) (a89 :double) (a90 :float) (a91 :long) (a92 :pointer)
     (a93 :unsigned-short) (a94 :float) (a95 :unsigned-char) (a96 :unsigned-char)
     (a97 :float) (a98 :unsigned-int) (a99 :float) (a100 :unsigned-short)
     (a101 :double) (a102 :unsigned-short) (a103 :unsigned-long)
     (a104 :unsigned-int) (a105 :unsigned-long) (a106 :pointer)
     (a107 :unsigned-char) (a108 :char) (a109 :char) (a110 :unsigned-short)
     (a111 :unsigned-long) (a112 :float) (a113 :short) (a114 :pointer)
     (a115 :long) (a116 :unsigned-short) (a117 :short) (a118 :double)
     (a119 :short) (a120 :int) (a121 :char) (a122 :unsigned-long) (a123 :long)
     (a124 :int) (a125 :pointer) (a126 :double) (a127 :unsigned-char))

  ;;#-(and)
  (let ((raw-args (list a1 a2 a3 a4 a5 a6 a7 a8 a9 a10
			a11 a12 a13 a14 a15 a16 a17 a18 a19 a20
			a21 a22 a23 a24 a25 a26 a27 a28 a29 a30
			a31 a32 a33 a34 a35 a36 a37 a38 a39 a40
			a41 a42 a43 a44 a45 a46 a47 a48 a49 a50
			a51 a52 a53 a54 a55 a56 a57 a58 a59 a60
			a61 a62 a63 a64 a65 a66 a67 a68 a69 a70
			a71 a72 a73 a74 a75 a76 a77 a78 a79 a80
			a81 a82 a83 a84 a85 a86 a87 a88 a89 a90
			a91 a92 a93 a94 a95 a96 a97 a98 a99 a100
			a101 a102 a103 a104 a105 a106 a107 a108 a109 a110
			a111 a112 a113 a114 a115 a116 a117 a118 a119 a120
			a121 a122 a123 a124 a125 a126 a127
			)))
    (loop for i from 1 and arg in raw-args do
	  (format t "a~A: ~A~%" i arg))
    (finish-output))

  (let ((args (list a1 (cffi:pointer-address a2) a3 (floor a4) a5 (floor a6)
                    (floor a7) a8 a9 (floor a10) (floor a11) (floor a12)
                    (cffi:pointer-address a13) a14 a15 (cffi:pointer-address a16) a17 a18
                    a19 a20 a21 a22 a23 a24 (cffi:pointer-address a25)
                    (cffi:pointer-address a26) a27 a28 a29 a30 a31 a32 a33 a34 a35
                    a36 (cffi:pointer-address a37) a38 a39 (floor a40) a41
                    (cffi:pointer-address a42) a43 a44 a45 (floor a46) a47 a48
                    (floor a49) a50 a51 a52 a53 a54 (floor a55) a56
                    (cffi:pointer-address a57) a58 (floor a59) a60 (floor a61) a62
                    (floor a63) a64 a65 a66 a67 a68 a69 (floor a70) a71
                    (cffi:pointer-address a72) a73 a74 (cffi:pointer-address a75) a76
                    (cffi:pointer-address a77) a78 (floor a79) (cffi:pointer-address a80)
                    a81 (floor a82) a83 a84 (cffi:pointer-address a85) (floor a86)
                    a87 a88 (floor a89) (floor a90) a91 (cffi:pointer-address a92)
                    a93 (floor a94) a95 a96 (floor a97) a98 (floor a99) a100
                    (floor a101) a102 a103 a104 a105 (cffi:pointer-address a106) a107
                    a108 a109 a110 a111 (floor a112) a113 (cffi:pointer-address a114)
                    a115 a116 a117 (floor a118) a119 a120 a121 a122 a123 a124
                    (cffi:pointer-address a125) (floor a126) a127)))
    ;;#-(and)
    (loop for i from 1 and arg in args do
	  (format t "a~A: ~A~%" i arg))
    (finish-output)

    (let ((val (reduce #'+ args)))
      (format t "~&In sum-127-no-ll: val = ~S." val) (finish-output)
      val)))


(cffi:defcfun "call_sum_127" :long-long (cb :pointer))

  
(cffi:defcallback sum-127 :long-long
      ((a1 :short) (a2 :char) (a3 :pointer) (a4 :float) (a5 :long) (a6 :double)
       (a7 :unsigned-long-long) (a8 :unsigned-short) (a9 :unsigned-char)
       (a10 :char) (a11 :char) (a12 :unsigned-short) (a13 :unsigned-long-long)
       (a14 :unsigned-short) (a15 :long-long) (a16 :unsigned-short)
       (a17 :unsigned-long-long) (a18 :unsigned-char) (a19 :unsigned-char)
       (a20 :unsigned-long-long) (a21 :long-long) (a22 :char) (a23 :float)
       (a24 :unsigned-int) (a25 :float) (a26 :float) (a27 :unsigned-int)
       (a28 :float) (a29 :char) (a30 :unsigned-char) (a31 :long) (a32 :long-long)
       (a33 :unsigned-char) (a34 :double) (a35 :long) (a36 :double)
       (a37 :unsigned-int) (a38 :unsigned-short) (a39 :long-long)
       (a40 :unsigned-int) (a41 :int) (a42 :unsigned-long-long) (a43 :long)
       (a44 :short) (a45 :unsigned-int) (a46 :unsigned-int)
       (a47 :unsigned-long-long) (a48 :unsigned-int) (a49 :long) (a50 :pointer)
       (a51 :unsigned-char) (a52 :char) (a53 :long-long) (a54 :unsigned-short)
       (a55 :unsigned-int) (a56 :float) (a57 :unsigned-char) (a58 :unsigned-long)
       (a59 :long-long) (a60 :float) (a61 :long) (a62 :float) (a63 :int)
       (a64 :float) (a65 :unsigned-short) (a66 :unsigned-long-long) (a67 :short)
       (a68 :unsigned-long) (a69 :long) (a70 :char) (a71 :unsigned-short)
       (a72 :long-long) (a73 :short) (a74 :double) (a75 :pointer)
       (a76 :unsigned-int) (a77 :char) (a78 :unsigned-int) (a79 :pointer)
       (a80 :pointer) (a81 :unsigned-char) (a82 :pointer) (a83 :unsigned-short)
       (a84 :unsigned-char) (a85 :long) (a86 :pointer) (a87 :char) (a88 :long)
       (a89 :unsigned-short) (a90 :unsigned-char) (a91 :double)
       (a92 :unsigned-long-long) (a93 :unsigned-short) (a94 :unsigned-short)
       (a95 :unsigned-int) (a96 :long) (a97 :char) (a98 :long) (a99 :char)
       (a100 :short) (a101 :unsigned-short) (a102 :unsigned-long)
       (a103 :unsigned-long) (a104 :short) (a105 :long-long) (a106 :long-long)
       (a107 :long-long) (a108 :double) (a109 :unsigned-short)
       (a110 :unsigned-char) (a111 :short) (a112 :unsigned-char) (a113 :long)
       (a114 :long-long) (a115 :unsigned-long-long) (a116 :unsigned-int)
       (a117 :unsigned-long) (a118 :unsigned-char) (a119 :long-long)
       (a120 :unsigned-char) (a121 :unsigned-long-long) (a122 :double)
       (a123 :unsigned-char) (a124 :long-long) (a125 :unsigned-char)
       (a126 :char) (a127 :long-long))

  (let ((raw-args (list a1 a2 a3 a4 a5 a6 a7 a8 a9 a10
			a11 a12 a13 a14 a15 a16 a17 a18 a19 a20
			a21 a22 a23 a24 a25 a26 a27 a28 a29 a30
			a31 a32 a33 a34 a35 a36 a37 a38 a39 a40
			a41 a42 a43 a44 a45 a46 a47 a48 a49 a50
			a51 a52 a53 a54 a55 a56 a57 a58 a59 a60
			a61 a62 a63 a64 a65 a66 a67 a68 a69 a70
			a71 a72 a73 a74 a75 a76 a77 a78 a79 a80
			a81 a82 a83 a84 a85 a86 a87 a88 a89 a90
			a91 a92 a93 a94 a95 a96 a97 a98 a99 a100
			a101 a102 a103 a104 a105 a106 a107 a108 a109 a110
			a111 a112 a113 a114 a115 a116 a117 a118 a119 a120
			a121 a122 a123 a124 a125 a126 a127
			)))
    (loop for i from 1 and arg in raw-args do
	  (format t "a~A: ~A~%" i arg))
    (finish-output))

  (let ((val (+ a1 a2 (cffi:pointer-address a3) (values (floor a4)) a5 (values (floor a6))
		a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22
		(values (floor a23)) a24 (values (floor a25)) (values (floor a26))
		a27 (values (floor a28)) a29 a30 a31 a32 a33 (values (floor a34))
		a35 (values (floor a36)) a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47
		a48 a49 (cffi:pointer-address a50) a51 a52 a53 a54 a55 (values (floor a56))
		a57 a58 a59 (values (floor a60)) a61 (values (floor a62)) a63
		(values (floor a64)) a65 a66 a67 a68 a69 a70 a71 a72 a73
		(values (floor a74)) (cffi:pointer-address a75) a76 a77 a78
		(cffi:pointer-address a79) (cffi:pointer-address a80) a81 (cffi:pointer-address a82)
		a83 a84 a85 (cffi:pointer-address a86) a87 a88 a89 a90 (values (floor a91))
		a92 a93 a94 a95 a96 a97 a98 a99 a100 a101 a102 a103 a104 a105 a106 a107
		(values (floor a108)) a109 a110 a111 a112 a113 a114 a115 a116 a117 a118
		a119 a120 a121 (values (floor a122)) a123 a124 a125 a126 a127)))
    (format t "~&In sum-127-no-ll: val = ~S.~%" val) (finish-output)
    val))


(cffi:defcvar "double_max" :double)
(cffi:defcvar "double_min" :double)


(cffi:defcfun "sum_127_no_ll" :long
    (a1 :long) (a2 :unsigned-long) (a3 :short) (a4 :unsigned-short) (a5 :float)
    (a6 :double) (a7 :unsigned-long) (a8 :float) (a9 :unsigned-char)
    (a10 :unsigned-short) (a11 :short) (a12 :unsigned-long) (a13 :double)
    (a14 :long) (a15 :unsigned-int) (a16 :pointer) (a17 :unsigned-int)
    (a18 :unsigned-short) (a19 :long) (a20 :float) (a21 :pointer) (a22 :float)
    (a23 :int) (a24 :int) (a25 :unsigned-short) (a26 :long) (a27 :long)
    (a28 :double) (a29 :unsigned-char) (a30 :unsigned-int) (a31 :unsigned-int)
    (a32 :int) (a33 :unsigned-short) (a34 :unsigned-int) (a35 :pointer)
    (a36 :double) (a37 :double) (a38 :long) (a39 :short) (a40 :unsigned-short)
    (a41 :long) (a42 :char) (a43 :long) (a44 :unsigned-short) (a45 :pointer)
    (a46 :int) (a47 :unsigned-int) (a48 :double) (a49 :unsigned-char)
    (a50 :unsigned-char) (a51 :float) (a52 :int) (a53 :unsigned-short)
    (a54 :double) (a55 :short) (a56 :unsigned-char) (a57 :unsigned-long)
    (a58 :float) (a59 :float) (a60 :float) (a61 :pointer) (a62 :pointer)
    (a63 :unsigned-int) (a64 :unsigned-long) (a65 :char) (a66 :short)
    (a67 :unsigned-short) (a68 :unsigned-long) (a69 :pointer) (a70 :float)
    (a71 :double) (a72 :long) (a73 :unsigned-long) (a74 :short)
    (a75 :unsigned-int) (a76 :unsigned-short) (a77 :int) (a78 :unsigned-short)
    (a79 :char) (a80 :double) (a81 :short) (a82 :unsigned-char) (a83 :float)
    (a84 :char) (a85 :int) (a86 :double) (a87 :unsigned-char) (a88 :int)
    (a89 :unsigned-long) (a90 :double) (a91 :short) (a92 :short)
    (a93 :unsigned-int) (a94 :unsigned-char) (a95 :float) (a96 :long)
    (a97 :float) (a98 :long) (a99 :long) (a100 :int) (a101 :int)
    (a102 :unsigned-int) (a103 :char) (a104 :char) (a105 :unsigned-short)
    (a106 :unsigned-int) (a107 :unsigned-short) (a108 :unsigned-short)
    (a109 :int) (a110 :long) (a111 :char) (a112 :double) (a113 :unsigned-int)
    (a114 :char) (a115 :short) (a116 :unsigned-long) (a117 :unsigned-int)
    (a118 :short) (a119 :unsigned-char) (a120 :float) (a121 :pointer)
    (a122 :double) (a123 :int) (a124 :long) (a125 :char) (a126 :unsigned-short)
    (a127 :float))

(defun test-sum-127-no-ll ()
      (sum-127-no-ll
       1442906394 520035521 -4715 50335 -13557.0 -30892.0d0 24061483 -23737.0
       22 2348 4986 104895680 8073.0d0 -571698147 102484400
       (cffi:make-pointer 507907275) 12733353 7824 -1275845284 13602.0
       (cffi:make-pointer 286958390) -8042.0 -773681663 -1289932452 31199 -154985357
       -170994216 16845.0d0 177 218969221 2794350893 6068863 26327 127699339
       (cffi:make-pointer 184352771) 18512.0d0 -12345.0d0 -179853040 -19981 37268
       -792845398 116 -1084653028 50494 (cffi:make-pointer 2105239646) -1710519651
       1557813312 2839.0d0 90 180 30580.0 -532698978 8623 9537.0d0 -10882 54
       184357206 14929.0 -8190.0 -25615.0 (cffi:make-pointer 235310526)
       (cffi:make-pointer 220476977) 7476055 1576685 -117 -11781 31479 23282640
       (cffi:make-pointer 8627281) -17834.0 10391.0d0 -1904504370 114393659 -17062
       637873619 16078 -891210259 8107 0 760.0d0 -21268 104 14133.0 10
       588598141 310.0d0 20 1351785456 16159552 -10121.0d0 -25866 24821
       68232851 60 -24132.0 -1660411658 13387.0 -786516668 -499825680
       -1128144619 111849719 2746091587 -2 95 14488 326328135 64781 18204
       150716680 -703859275 103 16809.0d0 852235610 -43 21088 242356110
       324325428 -22380 23 24814.0 (cffi:make-pointer 40362014) -14322.0d0
       -1864262539 523684371 -21 49995 -29175.0))


(cffi:defcfun "sum_127" :long-long
    (a1 :pointer) (a2 :pointer) (a3 :float) (a4 :unsigned-long) (a5 :pointer)
    (a6 :long-long) (a7 :double) (a8 :double) (a9 :unsigned-short) (a10 :int)
    (a11 :long-long) (a12 :long) (a13 :short) (a14 :unsigned-int) (a15 :long)
    (a16 :unsigned-char) (a17 :int) (a18 :double) (a19 :short) (a20 :short)
    (a21 :long-long) (a22 :unsigned-int) (a23 :unsigned-short) (a24 :short)
    (a25 :pointer) (a26 :short) (a27 :unsigned-short) (a28 :unsigned-short)
    (a29 :int) (a30 :long-long) (a31 :pointer) (a32 :int) (a33 :unsigned-long)
    (a34 :unsigned-long) (a35 :pointer) (a36 :unsigned-long-long) (a37 :float)
    (a38 :int) (a39 :short) (a40 :pointer) (a41 :unsigned-long-long)
    (a42 :long-long) (a43 :unsigned-long) (a44 :unsigned-long)
    (a45 :unsigned-long-long) (a46 :unsigned-long) (a47 :char) (a48 :double)
    (a49 :long) (a50 :unsigned-int) (a51 :int) (a52 :short) (a53 :pointer)
    (a54 :long) (a55 :unsigned-long-long) (a56 :int) (a57 :unsigned-short)
    (a58 :unsigned-long-long) (a59 :float) (a60 :pointer) (a61 :float)
    (a62 :unsigned-short) (a63 :unsigned-long) (a64 :float) (a65 :unsigned-int)
    (a66 :unsigned-long-long) (a67 :pointer) (a68 :double)
    (a69 :unsigned-long-long) (a70 :double) (a71 :double) (a72 :long-long)
    (a73 :pointer) (a74 :unsigned-short) (a75 :long) (a76 :pointer) (a77 :short)
    (a78 :double) (a79 :long) (a80 :unsigned-char) (a81 :pointer)
    (a82 :unsigned-char) (a83 :long) (a84 :double) (a85 :pointer) (a86 :int)
    (a87 :double) (a88 :unsigned-char) (a89 :double) (a90 :short) (a91 :long)
    (a92 :int) (a93 :long) (a94 :double) (a95 :unsigned-short)
    (a96 :unsigned-int) (a97 :int) (a98 :char) (a99 :long-long) (a100 :double)
    (a101 :float) (a102 :unsigned-long) (a103 :short) (a104 :pointer)
    (a105 :float) (a106 :long-long) (a107 :int) (a108 :long-long)
    (a109 :long-long) (a110 :double) (a111 :unsigned-long-long) (a112 :double)
    (a113 :unsigned-long) (a114 :char) (a115 :char) (a116 :unsigned-long)
    (a117 :short) (a118 :unsigned-char) (a119 :unsigned-char) (a120 :int)
    (a121 :int) (a122 :float) (a123 :unsigned-char) (a124 :unsigned-char)
    (a125 :double) (a126 :unsigned-long-long) (a127 :char))

(defun test-sum-127 ()
  (let ((val (sum-127
	      (cffi:make-pointer 2746181372) (cffi:make-pointer 177623060) -32334.0 3158055028
	      (cffi:make-pointer 242315091) 4288001754991016425 -21047.0d0 287.0d0 18722
	      243379286 -8677366518541007140 581399424 -13872 4240394881 1353358999
	      226 969197676 -26207.0d0 6484 11150 1241680089902988480 106068320 61865
	      2253 (cffi:make-pointer 866809333) -31613 35616 11715 1393601698
	      8940888681199591845 (cffi:make-pointer 1524606024) 805638893 3315410736
	      3432596795 (cffi:make-pointer 1490355706) 696175657106383698 -25438.0
	      1294381547 26724 (cffi:make-pointer 3196569545) 2506913373410783697
	      -4405955718732597856 4075932032 3224670123 2183829215657835866
	      1318320964 -22 -3786.0d0 -2017024146 1579225515 -626617701 -1456
	      (cffi:make-pointer 3561444187) 395687791 1968033632506257320 -1847773261
	      48853 142937735275669133 -17974.0 (cffi:make-pointer 2791749948) -14140.0
	      2707 3691328585 3306.0 1132012981 303633191773289330
	      (cffi:make-pointer 981183954) 9114.0d0 8664374572369470 -19013.0d0
	      -10288.0d0 -3679345119891954339 (cffi:make-pointer 3538786709) 23761
	      -154264605 (cffi:make-pointer 2694396308) 7023 997.0d0 1009561368 241
	      (cffi:make-pointer 2612292671) 48 1431872408 -32675.0d0
	      (cffi:make-pointer 1587599336) 958916472 -9857.0d0 111 -14370.0d0 -7308
	      -967514912 488790941 2146978095 -24111.0d0 13711 86681861 717987770
	      111 1013402998690933877 17234.0d0 -8772.0 3959216275 -8711
	      (cffi:make-pointer 3142780851) 9480.0 -3820453146461186120 1616574376
	      -3336232268263990050 -1906114671562979758 -27925.0d0 9695970875869913114
	      27033.0d0 1096518219 -12 104 3392025403 -27911 60 89 509297051
	      -533066551 29158.0 110 54 -9802.0d0 593950442165910888 -79)))
    (format t "~&In test-sum-127: val = ~S.~%" val) (finish-output)
    val
    )
  )

(cffi:defcfun "sum_127_for_32" :long-long
    (a1 :pointer) (a2 :pointer) (a3 :float) (a4 :unsigned-long-long) (a5 :pointer)
    (a6 :long-long) (a7 :double) (a8 :double) (a9 :unsigned-short) (a10 :int)
    (a11 :long-long) (a12 :long-long) (a13 :short) (a14 :unsigned-int) (a15 :long-long)
    (a16 :unsigned-char) (a17 :int) (a18 :double) (a19 :short) (a20 :short)
    (a21 :long-long) (a22 :unsigned-int) (a23 :unsigned-short) (a24 :short)
    (a25 :pointer) (a26 :short) (a27 :unsigned-short) (a28 :unsigned-short)
    (a29 :int) (a30 :long-long) (a31 :pointer) (a32 :int) (a33 :unsigned-long-long)
    (a34 :unsigned-long-long) (a35 :pointer) (a36 :unsigned-long-long) (a37 :float)
    (a38 :int) (a39 :short) (a40 :pointer) (a41 :unsigned-long-long)
    (a42 :long-long) (a43 :unsigned-long-long) (a44 :unsigned-long-long)
    (a45 :unsigned-long-long) (a46 :unsigned-long-long) (a47 :char) (a48 :double)
    (a49 :long-long) (a50 :unsigned-int) (a51 :int) (a52 :short) (a53 :pointer)
    (a54 :long-long) (a55 :unsigned-long-long) (a56 :int) (a57 :unsigned-short)
    (a58 :unsigned-long-long) (a59 :float) (a60 :pointer) (a61 :float)
    (a62 :unsigned-short) (a63 :unsigned-long-long) (a64 :float) (a65 :unsigned-int)
    (a66 :unsigned-long-long) (a67 :pointer) (a68 :double)
    (a69 :unsigned-long-long) (a70 :double) (a71 :double) (a72 :long-long)
    (a73 :pointer) (a74 :unsigned-short) (a75 :long-long) (a76 :pointer) (a77 :short)
    (a78 :double) (a79 :long-long) (a80 :unsigned-char) (a81 :pointer)
    (a82 :unsigned-char) (a83 :long-long) (a84 :double) (a85 :pointer) (a86 :int)
    (a87 :double) (a88 :unsigned-char) (a89 :double) (a90 :short) (a91 :long-long)
    (a92 :int) (a93 :long-long) (a94 :double) (a95 :unsigned-short)
    (a96 :unsigned-int) (a97 :int) (a98 :char) (a99 :long-long) (a100 :double)
    (a101 :float) (a102 :unsigned-long-long) (a103 :short) (a104 :pointer)
    (a105 :float) (a106 :long-long) (a107 :int) (a108 :long-long)
    (a109 :long-long) (a110 :double) (a111 :unsigned-long-long) (a112 :double)
    (a113 :unsigned-long-long) (a114 :char) (a115 :char) (a116 :unsigned-long-long)
    (a117 :short) (a118 :unsigned-char) (a119 :unsigned-char) (a120 :int)
    (a121 :int) (a122 :float) (a123 :unsigned-char) (a124 :unsigned-char)
    (a125 :double) (a126 :unsigned-long-long) (a127 :char))

(defun test-sum-127-for-32 ()
  (let ((val (sum-127-for-32
	      (cffi:make-pointer 2746181372) (cffi:make-pointer 177623060) -32334.0 3158055028
	      (cffi:make-pointer 242315091) 4288001754991016425 -21047.0d0 287.0d0 18722
	      243379286 -8677366518541007140 581399424 -13872 4240394881 1353358999
	      226 969197676 -26207.0d0 6484 11150 1241680089902988480 106068320 61865
	      2253 (cffi:make-pointer 866809333) -31613 35616 11715 1393601698
	      8940888681199591845 (cffi:make-pointer 1524606024) 805638893 3315410736
	      3432596795 (cffi:make-pointer 1490355706) 696175657106383698 -25438.0
	      1294381547 26724 (cffi:make-pointer 3196569545) 2506913373410783697
	      -4405955718732597856 4075932032 3224670123 2183829215657835866
	      1318320964 -22 -3786.0d0 -2017024146 1579225515 -626617701 -1456
	      (cffi:make-pointer 3561444187) 395687791 1968033632506257320 -1847773261
	      48853 142937735275669133 -17974.0 (cffi:make-pointer 2791749948) -14140.0
	      2707 3691328585 3306.0 1132012981 303633191773289330
	      (cffi:make-pointer 981183954) 9114.0d0 8664374572369470 -19013.0d0
	      -10288.0d0 -3679345119891954339 (cffi:make-pointer 3538786709) 23761
	      -154264605 (cffi:make-pointer 2694396308) 7023 997.0d0 1009561368 241
	      (cffi:make-pointer 2612292671) 48 1431872408 -32675.0d0
	      (cffi:make-pointer 1587599336) 958916472 -9857.0d0 111 -14370.0d0 -7308
	      -967514912 488790941 2146978095 -24111.0d0 13711 86681861 717987770
	      111 1013402998690933877 17234.0d0 -8772.0 3959216275 -8711
	      (cffi:make-pointer 3142780851) 9480.0 -3820453146461186120 1616574376
	      -3336232268263990050 -1906114671562979758 -27925.0d0 9695970875869913114
	      27033.0d0 1096518219 -12 104 3392025403 -27911 60 89 509297051
	      -533066551 29158.0 110 54 -9802.0d0 593950442165910888 -79)))
    (format t "~&In test-sum-127-for-32: val = ~S.~%" val) (finish-output)
    val
    )
  )

(cffi:defcfun "call_sum_127_from_c" :void)
(cffi:defcfun "call_sum_127_for_32_from_c" :void)


(defun run-test ()
  (call-just-say-hello (cffi:callback just-say-hello))
  (assert (= 10 (call-sum-4-long (cffi:callback sum-4-long))))
  (assert (= 36 (call-sum-8-long (cffi:callback sum-8-long))))
#|
  (assert (= 2008547941 (let ((val (call-sum-127-no-ll (cffi:callback sum-127-no-ll))))
				   (format t "~&call-sum-127-no-ll returned value: ~S.~%" val)
				   val)))
  (assert (= 8166570665645582011 (let ((val (call-sum-127 (cffi:callback sum-127))))
				   (format t "~&call-sum-127 returned value: ~S.~%" val)
				   val)))
|#
  (assert (= 796447501 (test-sum-127-no-ll)))
  (call-sum-127-from-c)
  (call-sum-127-for-32-from-c)
  ;;(assert (= 7758614658402721936 (test-sum-127-for-32)))
  (assert (= 7758614658402721936 (test-sum-127)))
  )


