;;;

;;(setq *compile-extra-options* '(:c-file t :data-file t :h-file t))
;;(setq compiler::*cc-flags* (concatenate 'base-string "-H " compiler::*cc-flags*))
;;(setq compiler::*trace-cc* t)
;;(setq compiler::*delete-compiler-internal-files* nil)
(proclaim '(optimize (debug 0)))

;(format t "~&enabled-fpe = ~S~%" (si:all-enabled-fpe))

#+(or) ;;#+mingw64
(setq compiler::*cc* "x86_64-w64-mingw32-gcc.exe"
      compiler::*ld* "x86_64-w64-mingw32-gcc.exe"
      compiler::*ar* "x86_64-w64-mingw32-ar.exe"
      compiler::*ranlib* "x86_64-w64-mingw32-ranlib.exe")

;(setq compiler::*delete-compiler-internal-files* nil)

	
;(setq *compile-verbose* nil)
;(setq *compile-print* nil)

;; (setq compiler::*suppress-compiler-messages* nil
;;       compiler::*suppress-compiler-warnings* nil
;;       compiler::*suppress-compiler-notes* nil)


;;(si:gc-off)

#+(or) ;; use logical pathnames,  **deprecated**
(progn
  (let* ((here (namestring (mk-ext:getcwd)))
	 (target (concatenate 'base-string here "**/*.*"))
	 (translation `(("**;*.*.*" ,target))))
    (format t "Setting logical host TEST: to ~S.~%" target)
    (si::pathname-translations "TEST" translation))

  #|
  #+:unix (si::pathname-translations "TEST" `(("**;*.*.*" "~/CL/MKCL/dev/mkcl/src/test/**/*.*")))
  #+:mingw32 (si::pathname-translations "TEST" `(("**;*.*.*" "D:/GNU/MinGW/msys/1.0/home/Jean-Claude/mkcl/src/test/**/*.*")))
  #+:mingw64 (si::pathname-translations "TEST" `(("**;*.*.*" "C:/Users/Jean-Claude/GNU2/msys/home/Jean-Claude/mkcl/src/test/**/*.*")))
  |#


  (defconstant +cmp-module-files+
    '("test:cmp2;cmpdefs.lsp"
      "test:cmp2;cmpmac.lsp"
      "test:cmp2;cmpinline.lsp"
      "test:cmp2;cmputil.lsp"
      "test:cmp2;cmptype.lsp"
      "test:cmp2;cmpbind.lsp"
      "test:cmp2;cmpblock.lsp"
      "test:cmp2;cmpcall.lsp"
      "test:cmp2;cmpcatch.lsp"
      "test:cmp2;cmpenv.lsp"
      "test:cmp2;cmpeval.lsp"
      "test:cmp2;cmpexit.lsp"
      "test:cmp2;cmpflet.lsp"
      "test:cmp2;cmpfun.lsp"
      "test:cmp2;cmpif.lsp"
      "test:cmp2;cmplam.lsp"
      "test:cmp2;cmplet.lsp"
      "test:cmp2;cmploc.lsp"
      "test:cmp2;cmpmap.lsp"
      "test:cmp2;cmpstack.lsp"
      "test:cmp2;cmpmulti.lsp"
      "test:cmp2;cmpspecial.lsp"
      "test:cmp2;cmptag.lsp"
      "test:cmp2;cmptop.lsp"
      "test:cmp2;cmpvar.lsp"
      "test:cmp2;cmpwt.lsp"
      "test:cmp2;cmpffi.lsp"
      "test:cmp2;cmpcbk.lsp"
      "test:cmp2;cmpct.lsp"
      "test:cmp2;cmpnum.lsp"
      "test:cmp2;cmpname.lsp"
      "test:cmp2;cmpopt.lsp"
      "test:cmp2;cmpprop.lsp"
      "test:cmp2;cmpclos.lsp"
      "test:cmp2;cmpstructures.lsp"
      "test:cmp2;cmparray.lsp"
      "test:cmp2;cmpmain.lsp"))
  ); progn

#+(and) ;; use simple relative physical pathnames
(defconstant +cmp-module-files+
    '("./cmp2/cmpdefs.lsp"
      "./cmp2/cmpmac.lsp"
      "./cmp2/cmpinline.lsp"
      "./cmp2/cmputil.lsp"
      "./cmp2/cmptype.lsp"
      "./cmp2/cmpbind.lsp"
      "./cmp2/cmpblock.lsp"
      "./cmp2/cmpcall.lsp"
      "./cmp2/cmpcatch.lsp"
      "./cmp2/cmpenv.lsp"
      "./cmp2/cmpeval.lsp"
      "./cmp2/cmpexit.lsp"
      "./cmp2/cmpflet.lsp"
      "./cmp2/cmpfun.lsp"
      "./cmp2/cmpif.lsp"
      "./cmp2/cmplam.lsp"
      "./cmp2/cmplet.lsp"
      "./cmp2/cmploc.lsp"
      "./cmp2/cmpmap.lsp"
      "./cmp2/cmpstack.lsp"
      "./cmp2/cmpmulti.lsp"
      "./cmp2/cmpspecial.lsp"
      "./cmp2/cmptag.lsp"
      "./cmp2/cmptop.lsp"
      "./cmp2/cmpvar.lsp"
      "./cmp2/cmpwt.lsp"
      "./cmp2/cmpffi.lsp"
      "./cmp2/cmpcbk.lsp"
      "./cmp2/cmpct.lsp"
      "./cmp2/cmpnum.lsp"
      "./cmp2/cmpname.lsp"
      "./cmp2/cmpopt.lsp"
      "./cmp2/cmpprop.lsp"
      "./cmp2/cmpclos.lsp"
      "./cmp2/cmpstructures.lsp"
      "./cmp2/cmparray.lsp"
      "./cmp2/cmpmain.lsp"))

(si:reset-allocation-statistics)
(si:reopen-package :compiler)
(si:reopen-package :cl)
(si:reopen-package :si)

;;(si:trace-closure-creation)
;(handler-case
 (unwind-protect
     (let ((si::*keep-documentation* nil))
       (time
	(mapc #'(lambda (x)
		  (terpri)
		  (princ ";; Compiling ")
		  (princ x)
		  (compile-file x #|:c-file t :h-file t :data-file t|#))
	      +cmp-module-files+
	      )
	)
       )
   (format t "~&Compilation finished!~%")
   (finish-output)
   )
;;  (condition (condition)
;;     (format t "~&[1] Compilation failed with condition: ~A.~%" condition)
;;     (finish-output)
;;     (format nil "~&[2] Compilation failed with condition: ~A.~%" condition)
;;   )
;;  )

(si:room-report "End of compilation")
(format t "~&Allocated memory: ~S.~%" (si:sample-allocation-statistics))
(SI:HASH-TABLES-STATISTICS)
(room)

(mk-ext:quit)

