
#define _GNU_SOURCE

#include <fenv.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <ucontext.h>

int main(int argc, char * argv[])
{
  int except_mask =  FE_DIVBYZERO | FE_INVALID | FE_OVERFLOW | FE_UNDERFLOW /* | FE_INEXACT  */;
  int status = feenableexcept(except_mask);

  {
    int mask = fegetexcept();

    if ( mask != except_mask )
      {
	printf("\nBefore getcontext(): fegetexcept returned: %d, expected: %d.\n", mask, except_mask);
	return 1;
      }

  }

  {
    ucontext_t ctx;

    status = getcontext(&ctx);

    if (status)
      {
	printf("\ngetcontext failed, errno: %d.\n", errno);
	return 1;
      }
      
  }

  printf("\nDone with getcontext()!\n"); fflush(NULL);
  
  {
    int mask = fegetexcept();

    if ( mask != except_mask )
      {
	printf("\nAfter getcontext(): fegetexcept returned: %d, expected: %d.\n", mask, except_mask);
	return 1;
      }

  }
  printf("\nAt end fegetexcept() returned %d, expected: %d.\n", fegetexcept(), except_mask);
  return 0;
}
